Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deMapConverter Namespace Reference

## Compounds
struct | Brush_t
struct | BrushPlane_t
struct | ClippedBrush_t
struct | ConvertInfo_t
struct | Entity_t
struct | entity_var_t
struct | Face_t
struct | FullData_t
struct | ParseInfo_t
struct | Vert
struct | GridEdge
struct | GridBox
struct | GridVert
class | VertexGrid
## Typedefs
typedef deTArray< BrushPlane_t >::iterator | Plane_Iterator
## Enumerations
enum | Plane_class_t { PLANE_FRONT, PLANE_BACK, PLANE_SPAN, PLANE_COINCIDE }
enum | FileType_t { MAPFILE_Undecided = -1, MAPFILE_Q1, MAPFILE_Q3, MAPFILE_HL, MAPFILE_Force32bit = 0x7fffffff }
enum | TextLine_t { MAP_Undecided = -1, MAP_None = 0, MAP_BraceOpen, MAP_BraceClose, MAP_Q1Plane, MAP_Q3Plane, MAP_HLPlane, MAP_Error_Mismatched_Parens, MAP_Error_Mismatched_Brackets, MAP_Force32bit = 0x7fffffff }
enum | TextData_t { MAPData_None = 0, MAPData_OpenParen, MAPData_OpenBracket, MAPData_CloseParen, MAPData_CloseBracket, MAPData_OpenBrace, MAPData_CloseBrace, MAPData_Quote, MAPData_Num, MAPData_Other, MAPData_Force32bit = 0x7fffffff }
enum | BrushContent_t { CONTENTS_EMPTY = -1, CONTENTS_SOLID = -2, CONTENTS_WATER = -3, CONTENTS_SLIME = -4, CONTENTS_LAVA = -5, CONTENTS_SKY = -6, CONTENTS_ORIGIN = -7, CONTENTS_CLIP = -8, CONTENTS_CURRENT_0 = -9, CONTENTS_CURRENT_90 = -10, CONTENTS_CURRENT_180 = -11, CONTENTS_CURRENT_270 = -12, CONTENTS_CURRENT_UP = -13, CONTENTS_CURRENT_DOWN = -14, CONTENTS_TRANSLUCENT = -15, CONTENTS_HINT = -16 }
## Functions
void | UnionAllBrushes (FullData_t *pData, Entity_t *pEntity, TiXmlDocument *xmlDoc, bool doUnion, bool doWeld)
deBoolean | CompilePolyMesh (FullData_t *pData, TiXmlDocument *xmlDoc, bool doUnion, bool doWeld)
deBoolean | VertOnEdge (deVec3d vert, const Face_t::Vert &end0, const Face_t::Vert &end1, Face_t::Vert &vOut, deDouble &pVal)
void | WeldVertices (deTArray< ClippedBrush_t > &clippedBrushes)
Plane_class_t | ClassifyPoint (const deVec3d &point, const BrushPlane_t &Plane)
Plane_class_t | ClassifyFace (const Face_t *pFace, const BrushPlane_t &Plane)
deBoolean | SplitEdge (Face_t::Vert &vOut, const Face_t::Vert &v0, const Face_t::Vert &v1, const BrushPlane_t &Plane)
void | SplitCoincidentalEdges (Face_t *pFace, Plane_Iterator planeIt, const Plane_Iterator &stop, const BrushPlane_t &CoincidePlane)
void | SplitFace (const Face_t *pFace, Face_t *&pFront, Face_t *&pBack, const BrushPlane_t &Plane, long &FrontVertSplit)
Face_t * | ClipFaceToPlanes (Face_t *pFace, Plane_Iterator planeIt, const Plane_Iterator &stop, bool bClipOnPlane)
void | ClipBrush (ClippedBrush_t &clipBrush, const Brush_t &planeBrush, bool bClipOnPlane)
void | CopyBrush (ClippedBrush_t &target, const Brush_t &source)
Entity_t * | FindEntityNamed (FullData_t *pData, const deString2 &name)
deString2 | GetEntityData (Entity_t *pEntity, deString2 name)
void | LoadMAP (const char *filename, deDouble Scale, IdeRenderTexture *DefaultTex, bool doUnion, bool doWeld, FullData_t &outData)
BrushContent_t | TextureContents (const char *const name)
FileType_t | IdentifyFileTypeFromPlaneDef (const ParseInfo_t &parseInfo)
deBoolean | NextLine (ParseInfo_t &parseInfo)
void | RewindToken (ParseInfo_t &info)
TextData_t | ParseToken (ParseInfo_t &info, deString2 &buffer, TextData_t expectation=MAPData_None)
deBoolean | ParseVertex (ParseInfo_t &info, deVec3d &Vertex, deString2 &buffer, deBoolean ThrowFailure)
deBoolean | ParseBracketTuple (ParseInfo_t &info, deVec3d &Axis, deDouble &Offset, deString2 &buffer, deBoolean ThrowFailure)
void | GetAxisBase (const deVec3d &Normal0, deVec3d &texS, deVec3d &texT)
BrushContent_t | ParsePlane (ConvertInfo_t *pInfo, FullData_t *pData, BrushPlane_t *pPlane)
void | ParseBrush (ConvertInfo_t *pInfo, FullData_t *pData, Entity_t *pEntity)
deBoolean | ParseEntity (ConvertInfo_t *pInfo, FullData_t *pData, Entity_t *pEntity)
void | ParseMAPFile (ConvertInfo_t *pInfo, FullData_t *pData)
char * | ReadFile (ConvertInfo_t *pInfo, long &size)
deBoolean | PlaneIntersectionPoint (const BrushPlane_t &p1, const BrushPlane_t &p2, const BrushPlane_t &p3, deVec3d &p)
void | IntersectBrushFaces (FullData_t *pData, Brush_t *pBrush)
void | ThrowParseError (const ParseInfo_t &parseInfo, const char *expected, const char *got)
## Variables
const double | Plane_Epsilon = 0.00001
const double | Edge_Epsilon = 0.00001

## Typedef Documentation

typedef deTArray<BrushPlane_t>::iterator deMapConverter::Plane_Iterator

## Enumeration Type Documentation

enum deMapConverter::BrushContent_t

  | Enumeration values:
  CONTENTS_EMPTY |
  CONTENTS_SOLID |
  CONTENTS_WATER |
  CONTENTS_SLIME |
  CONTENTS_LAVA |
  CONTENTS_SKY |
  CONTENTS_ORIGIN |
  CONTENTS_CLIP |
  CONTENTS_CURRENT_0 |
  CONTENTS_CURRENT_90 |
  CONTENTS_CURRENT_180 |
  CONTENTS_CURRENT_270 |
  CONTENTS_CURRENT_UP |
  CONTENTS_CURRENT_DOWN |
  CONTENTS_TRANSLUCENT |
  CONTENTS_HINT |

enum deMapConverter::FileType_t

  | Enumeration values:
  MAPFILE_Undecided |
  MAPFILE_Q1 |
  MAPFILE_Q3 |
  MAPFILE_HL |
  MAPFILE_Force32bit |

enum deMapConverter::Plane_class_t

  | Enumeration values:
  PLANE_FRONT |
  PLANE_BACK |
  PLANE_SPAN |
  PLANE_COINCIDE |

enum deMapConverter::TextData_t

  | Enumeration values:
  MAPData_None |
  MAPData_OpenParen |
  MAPData_OpenBracket |
  MAPData_CloseParen |
  MAPData_CloseBracket |
  MAPData_OpenBrace |
  MAPData_CloseBrace |
  MAPData_Quote |
  MAPData_Num |
  MAPData_Other |
  MAPData_Force32bit |

enum deMapConverter::TextLine_t

  | Enumeration values:
  MAP_Undecided |
  MAP_None |
  MAP_BraceOpen |
  MAP_BraceClose |
  MAP_Q1Plane |
  MAP_Q3Plane |
  MAP_HLPlane |
  MAP_Error_Mismatched_Parens |
  MAP_Error_Mismatched_Brackets |
  MAP_Force32bit |

## Function Documentation

Plane_class_t ClassifyFace | ( | const Face_t * | pFace,
|  | const BrushPlane_t & | Plane
| ) |

Plane_class_t ClassifyPoint | ( | const deVec3d & | point,
|  | const BrushPlane_t & | Plane
| ) |

void deMapConverter::ClipBrush | ( | ClippedBrush_t & | clipBrush,
|  | const Brush_t & | planeBrush,
|  | bool | bClipOnPlane
| ) |

Face_t* ClipFaceToPlanes | ( | Face_t * | pFace,
|  | Plane_Iterator | planeIt,
|  | const Plane_Iterator & | stop,
|  | bool | bClipOnPlane
| ) |

deBoolean CompilePolyMesh | ( | FullData_t * | pData,
|  | TiXmlDocument * | xmlDoc,
|  | bool | doUnion,
|  | bool | doWeld
| ) |

void deMapConverter::CopyBrush | ( | ClippedBrush_t & | target,
|  | const Brush_t & | source
| ) |

Entity_t * deMapConverter::FindEntityNamed | ( | FullData_t * | pData,
|  | const deString2 & | name
| ) |

void deMapConverter::GetAxisBase | ( | const deVec3d & | Normal0,
|  | deVec3d & | texS,
|  | deVec3d & | texT
| ) |

deString2 deMapConverter::GetEntityData | ( | Entity_t * | pEntity,
|  | deString2 | name
| ) |

FileType_t deMapConverter::IdentifyFileTypeFromPlaneDef | ( | const ParseInfo_t & | parseInfo | ) |

void IntersectBrushFaces | ( | FullData_t * | pData,
|  | Brush_t * | pBrush
| ) |

void deMapConverter::LoadMAP | ( | const char * | filename,
|  | deDouble | Scale,
|  | IdeRenderTexture * | DefaultTex,
|  | bool | doUnion,
|  | bool | doWeld,
|  | FullData_t & | outData
| ) |

deBoolean deMapConverter::NextLine | ( | ParseInfo_t & | parseInfo | ) |

deBoolean deMapConverter::ParseBracketTuple | ( | ParseInfo_t & | info,
|  | deVec3d & | Axis,
|  | deDouble & | Offset,
|  | deString2 & | buffer,
|  | deBoolean | ThrowFailure
| ) |

void deMapConverter::ParseBrush | ( | ConvertInfo_t * | pInfo,
|  | FullData_t * | pData,
|  | Entity_t * | pEntity
| ) |

deBoolean deMapConverter::ParseEntity | ( | ConvertInfo_t * | pInfo,
|  | FullData_t * | pData,
|  | Entity_t * | pEntity
| ) |

void deMapConverter::ParseMAPFile | ( | ConvertInfo_t * | pInfo,
|  | FullData_t * | pData
| ) |

BrushContent_t deMapConverter::ParsePlane | ( | ConvertInfo_t * | pInfo,
|  | FullData_t * | pData,
|  | BrushPlane_t * | pPlane
| ) |

TextData_t deMapConverter::ParseToken | ( | ParseInfo_t & | info,
|  | deString2 & | buffer,
|  | TextData_t | expectation = MAPData_None
| ) |

deBoolean deMapConverter::ParseVertex | ( | ParseInfo_t & | info,
|  | deVec3d & | Vertex,
|  | deString2 & | buffer,
|  | deBoolean | ThrowFailure
| ) |

deBoolean PlaneIntersectionPoint | ( | const BrushPlane_t & | p1,
|  | const BrushPlane_t & | p2,
|  | const BrushPlane_t & | p3,
|  | deVec3d & | p
| ) |

char * deMapConverter::ReadFile | ( | ConvertInfo_t * | pInfo,
|  | long & | size
| ) |

void deMapConverter::RewindToken | ( | ParseInfo_t & | info | ) |

void SplitCoincidentalEdges | ( | Face_t * | pFace,
|  | Plane_Iterator | planeIt,
|  | const Plane_Iterator & | stop,
|  | const BrushPlane_t & | CoincidePlane
| ) |

deBoolean deMapConverter::SplitEdge | ( | Face_t::Vert & | vOut,
|  | const Face_t::Vert & | v0,
|  | const Face_t::Vert & | v1,
|  | const BrushPlane_t & | Plane
| ) |

void SplitFace | ( | const Face_t * | pFace,
|  | Face_t *& | pFront,
|  | Face_t *& | pBack,
|  | const BrushPlane_t & | Plane,
|  | long & | FrontVertSplit
| ) |

BrushContent_t TextureContents | ( | const char *const | name | ) |

void ThrowParseError | ( | const ParseInfo_t & | parseInfo,
|  | const char * | expected,
|  | const char * | got
| ) |

void UnionAllBrushes | ( | FullData_t * | pData,
|  | Entity_t * | pEntity,
|  | TiXmlDocument * | xmlDoc,
|  | bool | doUnion,
|  | bool | doWeld
| ) |

deBoolean VertOnEdge | ( | deVec3d | vert,
|  | const Face_t::Vert & | end0,
|  | const Face_t::Vert & | end1,
|  | Face_t::Vert & | vOut,
|  | deDouble & | pVal
| ) |

void deMapConverter::WeldVertices | ( | deTArray< ClippedBrush_t > & | clippedBrushes | ) |

## Variable Documentation

const double deMapConverter::Edge_Epsilon = 0.00001

const double deMapConverter::Plane_Epsilon = 0.00001